/* strucTest.c */
/*Zeiger und Strukturen am Bsp. einer "MNI-Datenbank"*/
#include "strucTest.h"

/* *********************************************************************** */
   char *namXpath (char *namPath)
/* *********************************************************************** */
{ /*Extraktion des Programmnamens aus dem uebergebenen Pfad:*/
#ifdef  MORE_STRUCT1
#endif//MORE_STRUCT1
  return namPath;
}

/* *********************************************************************** */
   int randRang(int rangeMin, int rangeMax)
/* *********************************************************************** */
{ /*Pseudo-Zufallszahlen innerhalb eines Zahlenintervalls (range):*/
  int randR=0;

#ifdef  MORE_STRUCT2
#else //MORE_STRUCT2
  /*Version MSDN-Onlinehilfe (angepasst):*/
  randR = (int)(((double) rand() / RAND_MAX) * rangeMax + rangeMin);
#endif//MORE_STRUCT2

  return (randR);
}

/* *********************************************************************** */
   int setStud (Stud *defSt, Vorlesg *BS_V)
/* *********************************************************************** */
{ static int LfdNr=1;
         int j1=0;

  sprintf (defSt->Name, "%c.%c.", randRang('A','Z'), CYCLIC(LfdNr,'A','Z'));

  defSt->Matrikel = LfdNr;
  defSt->nLeist = 3;
  /*Speicherplatz-Reservierung und Zuweisung der Leistungen:*/
#ifdef  MORE_STRUCT3
#endif//MORE_STRUCT3
  LfdNr++;
  return OK;
}

/* *********************************************************************** */
   int main(int argc, char *argv[]) 
/* *********************************************************************** */
{ Prof    BS_P[PROF];
  Stud    BS_S[STUD];
  Vorlesg BS_V[VORL];
  int     j1=5, j2=8; // Mit (-2)...(3) probieren!

#ifdef  DEBUG
  /*Groesse beteiligter Strukturen:*/
  printf (" sizeof(struct Fach)= %d\n\r", sizeof(struct Fach));
  printf (" sizeof(Vorlesg)    = %d\n\r", sizeof(Vorlesg));
  printf (" sizeof(Prof)       = %d\n\r", sizeof(Prof));
  printf (" sizeof(Leistg)     = %d\n\r", sizeof(Leistg));
  printf (" sizeof(Stud)       = %d\n\r", sizeof(Stud));
  /*Zufallszahlen-Test, bis ESC gedrueckt wird:*/
  printf ("\n\r Pseudo-Zufallszahlen zwischen %d und %d:", j1, j2);
  printf ("\n\r (Bel. Taste / Weiter mit Esc)\n\r");
  while (_getch() != ESC) { printf("%6d\n", randRang(j1,j2)); } system("cls");
#else //DEBUG
  /*Initialisierung der Zufallszahlen fuer diesen Start:*/
  srand((unsigned)time(NULL));
#endif//DEBUG

  /*Eigentlicher Programmstart:*/
  printf (" Sie haben das Programm \"%s\" gestartet\n\n\r", namXpath(argv[0]));

  /*Angebotene Vorlesungen:*/
  strcpy (BS_V[0].FachName, "KonzSysProg"); BS_V[0].FachSWS = 4;
  strcpy (BS_V[1].FachName, "Comp.Grafik"); BS_V[1].FachSWS = 3;
  strcpy (BS_V[2].FachName, "BildVerarb."); BS_V[2].FachSWS = 2;
  strcpy (BS_V[3].FachName, "MathematikI"); BS_V[3].FachSWS = 6;
  strcpy (BS_V[4].FachName, "Th.Physik I"); BS_V[4].FachSWS = 3;

  /*Professoren:*/
  for (j1=0; j1<PROF; j1++)
  { sprintf (BS_P[j1].Name, "%c.%c.", CYCLIC(j1+1,'A','Z'), CYCLIC(j1+1,'C','Z'));
    BS_P[j1].nVorl=3;
    BS_P[j1].Vorl = (Vorlesg *)calloc (BS_P[j1].nVorl, sizeof(Vorlesg));
    if (!BS_P[j1].Vorl) { printf("Kein Speicher fuer Prof[%d]!\n", j1); _getch(); exit(1); }
    printf (" Prof. %s liest z.Z.:\n\r", BS_P[j1].Name);
    for (j2=0; j2<BS_P[j1].nVorl; j2++)
    { BS_P[j1].Vorl[j2] = BS_V[(j1+j2)%VORL]; //Strukturzuweisung
      printf (" %s (%d SWS)\n\r", 
              BS_P[j1].Vorl[j2].FachName, BS_P[j1].Vorl[j2].FachSWS );
    } printf ("\n\r");
  }

  /*Stichprobe als Plausibilitaetskontrolle:*/
    printf (" Speicheradressen:\n\r");
    printf (" BS_P[0].Vorl[1]:%8d\n\r", &BS_P[0].Vorl[1]);
    printf (" BS_P[0].Vorl[0]:%8d\n\r", &BS_P[0].Vorl[0]);
#ifdef  MORE_STRUCT4
#else //MORE_STRUCT4
    j1 = &BS_P[0].Vorl[1] - &BS_P[0].Vorl[0];
#endif//MORE_STRUCT4
    printf (" Differenz:      %8d\n\n\r", j1);
    if (j1 != sizeof(Vorlesg)) printf(" Codierungsfehler!\n\n\r"); _getch(); 

  /*Studierende:*/
  for (j1=0; j1<STUD; j1++)
  { if (!setStud (&BS_S[j1], BS_V)) { printf ("Fehler!"); _getch(); exit(0); }
    printf (" Herr/Frau %s (Matr. %d) bekam: \n\r", BS_S[j1].Name, BS_S[j1].Matrikel);
    for (j2=0; j2<BS_S[j1].nLeist; j2++)
    {  printf ("\tin %s die Note \"%3.1f\"\n\r", 
             BS_S[j1].Leist[j2].FachName, BS_S[j1].Leist[j2].FachNote); 
    }  printf ("\n\r");
  }

  printf ("\n\r Ende!\n\r(bel. Taste)");  _getch();
  return 1;
}
